<?php
/**
 * @name		resetACL.php
 * @desc		This file resets the ACL settings in a Joomla 2.5 website. The first part of the file is copied from the default index.php under the administrator folder.
 * @note		This file should be FTP'd to your administrator folder and should be run from there. This file should be run only once.
 * @copyright	2013 itoctopus ( http://www.itoctopus.com )
 * @license		GNU General Public License version 2 or later
 * @disclaimer	User at your own risk. itoctopus or any entity associated with it cannot be held liable for any issues caused directly or indirectly by the use of this script.
 */

// Set flag that this is a parent file
define('_JEXEC', 1);
define('DS', DIRECTORY_SEPARATOR);

if (file_exists(dirname(__FILE__) . '/defines.php')) {
	include_once dirname(__FILE__) . '/defines.php';
}

if (!defined('_JDEFINES')) {
	define('JPATH_BASE', dirname(__FILE__));
	require_once JPATH_BASE.'/includes/defines.php';
}

require_once JPATH_BASE.'/includes/framework.php';
require_once JPATH_BASE.'/includes/helper.php';
require_once JPATH_BASE.'/includes/toolbar.php';

// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;

// Instantiate the application.
$app = JFactory::getApplication('administrator');

// Initialise the application.
$app->initialise(array(
	'language' => $app->getUserState('application.lang')
));

$db = JFactory::getDbo();

$sql = "DROP TABLE `#__usergroups`;";
$db->setQuery($sql);
$db->query();

$sql = "CREATE TABLE IF NOT EXISTS `#__usergroups` ( `id` int(10) unsigned NOT NULL auto_increment COMMENT 'Primary Key', `parent_id` int(10) unsigned NOT NULL default '0' COMMENT 'Adjacency List Reference Id', `lft` int(11) NOT NULL default '0' COMMENT 'Nested set lft.', `rgt` int(11) NOT NULL default '0' COMMENT 'Nested set rgt.', `title` varchar(100) NOT NULL default '', PRIMARY KEY (`id`), UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`), KEY `idx_usergroup_title_lookup` (`title`), KEY `idx_usergroup_adjacency_lookup` (`parent_id`), KEY `idx_usergroup_nested_set_lookup` USING BTREE (`lft`,`rgt`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=13 ;";
$db->setQuery($sql);
$db->query();

$sql = "INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES (1, 0, 1, 20, 'Public'), (2, 1, 6, 17, 'Registered'), (3, 2, 7, 14, 'Author'), (4, 3, 8, 11, 'Editor'), (5, 4, 9, 10, 'Publisher'), (6, 1, 2, 5, 'Manager'), (7, 6, 3, 4, 'Administrator'), (8, 1, 18, 19, 'Super Users'), (10, 3, 12, 13, 'Shop Suppliers (Example)'), (12, 2, 15, 16, 'Customer Group (Example)');";
$db->setQuery($sql);
$db->query();

$sql = "SELECT id FROM `#__users` ORDER BY id ASC LIMIT 0, 1";
$db->setQuery($sql);
$superUserID = $db->loadResult();

sql = "DROP TABLE `#__user_usergroup_map`;";
$db->setQuery($sql);
$db->query();

$sql = "CREATE TABLE IF NOT EXISTS `#__user_usergroup_map` ( `user_id` int(10) unsigned NOT NULL default '0' COMMENT 'Foreign Key to #__users.id', `group_id` int(10) unsigned NOT NULL default '0' COMMENT 'Foreign Key to #__usergroups.id', PRIMARY KEY (`user_id`,`group_id`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8;";
$db->setQuery($sql);
$db->query();

$sql = "INSERT INTO `#__user_usergroup_map` (`user_id`, `group_id`) VALUES (".$superUserID.", 8);";
$db->setQuery($sql);
$db->query();

$sql = "DROP TABLE `#__viewlevels`;";
$db->setQuery($sql);
$db->query();

$sql = "CREATE TABLE IF NOT EXISTS `#__viewlevels` ( `id` int(10) unsigned NOT NULL auto_increment COMMENT 'Primary Key', `title` varchar(100) NOT NULL default '', `ordering` int(11) NOT NULL default '0', `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.', PRIMARY KEY (`id`), UNIQUE KEY `idx_assetgroup_title_lookup` (`title`) ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;";
$db->setQuery($sql);
$db->query();

$sql = "INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES (1, 'Public', 0, '[1]'), (2, 'Registered', 1, '[6,2,8]'), (3, 'Special', 2, '[6,3,8]'), (4, 'Customer Access Level (Example)', 3, '[6,3,12]');";
$db->setQuery($sql);
$db->query();

$sql = "SELECT username FROM `#__users` ORDER BY id ASC LIMIT 0, 1";
$db->setQuery($sql);
$username = $db->loadResult();

echo('The username of the user you should use to login to your website is: '.$username);